package pl.asie.foamfix.tests;

import net.minecraft.init.Blocks;
import net.minecraft.init.Bootstrap;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Scope;
import org.openjdk.jmh.annotations.State;
import org.openjdk.jmh.runner.Runner;
import org.openjdk.jmh.runner.RunnerException;
import org.openjdk.jmh.runner.options.Options;
import org.openjdk.jmh.runner.options.OptionsBuilder;

@State(Scope.Thread)
public class BenchmarkItemStack {
    private static final Item item, itemair;

    static {
        Bootstrap.func_151354_b();
        item = Items.field_179568_as;
        itemair = Items.field_190931_a;
    }

    @Benchmark
    public void airLookupMap() {
        boolean b = item == Item.func_150898_a(Blocks.field_150350_a);
    }

    @Benchmark
    public void airLookupCached() {
        Item i = itemair == null ? Item.func_150898_a(Blocks.field_150350_a) : itemair;
        boolean b = item == i;
    }

    public static void main(String[] args) throws RunnerException {
        Options opt = new OptionsBuilder()
                .include(BenchmarkItemStack.class.getSimpleName())
                .forks(1)
                .build();

        new Runner(opt).run();
    }
}
